/**
 * Ein einfaches Protokoll fr den Chatserver.
 * 
 * @author Bernd Gramlich nach den Oracle Java Tutorials. 
 * @version 2014-12-09
 */
public class Serverprotokoll
{   
    /*
     * Der Dialogzustand des Protokolls.
     */
    private int zustand;

    /*
     * Mgliche Werte des Dialogzustands.
     */
    private final int NICK_EINGEBEN = 0;
    private final int CHATTEN       = 1;

    /*
     * Wer ist die Adressatin? (Falls null,
     * ist die Antwort ffentlich. Falls leer, ist
     * die Antwort an einen selbst gerichtet.)
     */
    private String adressatin;

    /**
     * Konstruktor.
     * Zu Dialoganfang muss man den eigenen Nick eingeben.
     */
    public Serverprotokoll ()
    {
        zustand = NICK_EINGEBEN;
    }

    /**
     * Verarbeite die eingabeZeile zu einer ausgabeZeile.
     */
    public String verarbeite (String eingabeZeile)
    {
        String ausgabeZeile = "";
        adressatin = null;

        if (eingabeZeile == null)
        {
            adressatin = "";
            ausgabeZeile = "Welcome!  Enter nick:";
        }
        else
        {
            switch (zustand)
            {
                case NICK_EINGEBEN:
                adressatin = "";
                ausgabeZeile = "nick " + eingabeZeile;
                break;

                case CHATTEN:
                if (eingabeZeile.equals ("commands"))
                {
                    adressatin = "";
                    ausgabeZeile = "commands | ayt | quit | tell so sth | nick name";
                }
                else if (eingabeZeile.equals ("ayt"))
                {
                    adressatin = "";
                    ausgabeZeile = "Yes.";
                }
                else if (eingabeZeile.equals ("quit"))
                {
                    adressatin = "";
                    ausgabeZeile = "Bye.";
                }
                else if (eingabeZeile.startsWith ("tell "))
                {
                    String[] bestandteile = eingabeZeile.split (" ");

                    if (bestandteile.length > 2)
                    {
                        adressatin = bestandteile[1];

                        ausgabeZeile = " tells you: " + eingabeZeile.substring (bestandteile[1].length () + 6);
                    }
                    else if (bestandteile.length == 2)
                    {
                        adressatin = bestandteile[1];

                        ausgabeZeile = " is speechless.";
                    }
                    else
                    {
                        ausgabeZeile = eingabeZeile;
                    }
                }
                else
                {
                    ausgabeZeile = eingabeZeile;
                } 
            }
        }

        return ausgabeZeile;
    }

    /**
     * Vermerke, dass ein gltiger Nick eingeben wurde.
     */
    public void vermerkeNick ()
    {
        zustand = CHATTEN;
    }

    /**
     * Nenne die Adressatin.
     */
    public String gibAdressatin ()
    {
        return adressatin;
    }
}
